package rmihelloworld;

import java.rmi.registry.Registry;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;

	public class HelloServerImpl implements HelloServer {
	        
	    public String sayHello() {
	        return "Hello, world!";
	    }
	        
	    public static void main(String args[]) {
	    	
	        try {
	            HelloServerImpl helloServer = new HelloServerImpl();
	            HelloServer helloServerStub = (HelloServer) UnicastRemoteObject.exportObject(helloServer, 0);

	            // Registra il riferimento remoto (stub) dell'helloServer nel registry e lo identifica
	            // con la stringa "Hello".
	            Registry registry = LocateRegistry.getRegistry();
	            registry.rebind("Hello", helloServerStub);

	            System.out.println("Server ready");
	        } catch (Exception e) {
	            System.err.println("Server exception: " + e.toString());
	            e.printStackTrace();
	        }
	    }
}
